﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Phase1.Tests
{
    class TemperatureSpanComponent
    {
        internal int GetDayOfMinimumTemperatureDifference(string contentOfWeatherData)
        {
            string[] lines = contentOfWeatherData.Split('\n');
            List<List<string>> columnsOfLines = new List<List<string>>();
            int returnDay = 0;
            for (int i = 0; i < lines.Count(); i++)
            {
                string line = lines[i].TrimStart();
                line = line.Replace("*", "");
                while (line.Contains("  "))
                {
                    line = line.Replace("  ", " ");
                }
                List<string> newLine = line.Split(' ').ToList();
                int day;
                if (int.TryParse(newLine[0], out day)
                    && day >= 1 && day <= 30)
                {
                    columnsOfLines.Add(newLine);
                }
            }
            // Variante A
            returnDay = (from c in columnsOfLines
                         let diffT = int.Parse(c[1]) - int.Parse(c[2])
                         orderby diffT ascending
                         select int.Parse(c[0])).First();

            returnDay =
                columnsOfLines.OrderBy(c =>
                                           {
                                               int diffT = int.Parse(c[1]) - int.Parse(c[2]);
                                               return diffT;
                                           }).Select(c => int.Parse(c[0])).First();


            // Variante B
            var splittedPartLines =
                from line in columnsOfLines
                select new { day = int.Parse(line[0]), max = int.Parse(line[1]), min = int.Parse(line[2]) };
            var tempDiffPartLines =
                from line in splittedPartLines
                let tempDiff = line.max - line.min
                select new { line.day, tempDiff };
            returnDay =
                (from tempDiffParts in tempDiffPartLines
                 where tempDiffParts.tempDiff == tempDiffPartLines.Min(arg => arg.tempDiff)
                 select tempDiffParts.day).First();

            // Original
            int diff = 999;
            foreach (List<string> line in columnsOfLines)
            {
                int diffTemp = int.Parse(line[1]) - int.Parse(line[2]);
                if (diffTemp < diff)
                {
                    returnDay = int.Parse(line[0]);
                    diff = diffTemp;
                }
            }

            // (SELECT TOP 1 ersteSpalte, zweiteSpalte - dritteSpalte FROM columnsOfLines
            // ORDER BY 2 DESC).ToLinq()
            
            return returnDay;
        }
    }
}
